package aexp.intentsender;

import aexp.data.TwoNumbers;
import android.app.Activity;
import android.os.Bundle;
import android.widget.Button;
import android.widget.TextView;
import android.content.Intent;
import android.content.Context;
import android.view.View;

public class IntentSender extends Activity
{
	public final static int ACTIVITY_INVOKE = 0;
    private Context thisContext = null;
		
    /** Called with the activity is first created. */
    @Override
    public void onCreate(Bundle icicle)
    {
        super.onCreate(icicle);
        setContentView(R.layout.main);
        thisContext = (Context)this;
        Button invokeInternalButton = (Button) findViewById(R.id.invokeact);
        invokeInternalButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
				startExplicitSubActivity( "aexp.intentsender", 
						"aexp.intentsender.IntentReceiver",2,3 );
     		}
        });
        Button invokeExternalButton = (Button) findViewById(R.id.invokeext);
        invokeExternalButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
				startExplicitSubActivity( "aexp.intentreceiver", 
						"aexp.intentreceiver.IntentReceiver",4,5 );
     		}
        });
        Button invokeImplicitButton = (Button) findViewById(R.id.invokeimp);
        invokeImplicitButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
			  Intent i = new Intent();
	  		  i.setAction( "aexp.intentsender.add" );
	  		  TwoNumbers item = new TwoNumbers( 5,6);
	  		  i.putExtra( "item",item );
              startActivityForResult(i, ACTIVITY_INVOKE);
     		}
        });
     }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent resIntent) {
      super.onActivityResult(requestCode, resultCode, resIntent);

      switch(requestCode) {
	     case ACTIVITY_INVOKE:
	     		Integer r = resIntent.getIntExtra( "r",0 );
	     		if( r != null ) {
				  TextView t = (TextView)findViewById(R.id.invokeact_result);
				  t.setText( r.toString() );
	     	    }
    	        break;
      }
    }

    private void startExplicitSubActivity( String pkgName, String className,
			int i1,int i2 ) {
	  Intent i = new Intent();
	  i.setClassName( pkgName, className );
	  TwoNumbers item = new TwoNumbers( i1,i2);
	  i.putExtra( "item",item );
	  startActivityForResult(i, ACTIVITY_INVOKE);
	}
}
